"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _spClient = require("sp-client");

var _spClient2 = _interopRequireDefault(_spClient);

var _spUtils = require("sp-utils");

var _three = require("three");

var THREE = _interopRequireWildcard(_three);

var _spPeerStream = require("sp-peer-stream");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SPCamera = function (_Component) {
  _inherits(SPCamera, _Component);

  function SPCamera() {
    _classCallCheck(this, SPCamera);

    var _this = _possibleConstructorReturn(this, (SPCamera.__proto__ || Object.getPrototypeOf(SPCamera)).call(this));

    _this.initStream = _this.initStream.bind(_this);
    return _this;
  }

  _createClass(SPCamera, [{
    key: "getRef",
    value: function getRef(elem) {
      if (!elem) {
        return;
      }
      this.ref = elem;
      this.start();
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      this.peer = (0, _spPeerStream.getPeer)(this.props.userId);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.peer.off("stream", this.initStream);
      this.cleanupThree();
    }
  }, {
    key: "start",
    value: function start() {
      // Retrieve is like "on" but immediately resolves if we already have one.
      this.peer.retrieve("stream", this.initStream);
    }
  }, {
    key: "initStream",
    value: function initStream(stream) {
      var _this2 = this;

      if (this.ref.srcObject === stream) {
        return;
      }
      this.ref.srcObject = stream;
      return new Promise(function (resolve, reject) {
        var handler = function handler() {
          _this2.ref.removeEventListener("loadedmetadata", handler);
          resolve();
        };
        _this2.ref.addEventListener("loadedmetadata", handler);
      }).then(function () {
        _this2.initThree(_this2.props);
      }).catch(function (err) {
        _spClient2.default.error(err);
      });
    }
  }, {
    key: "initThree",
    value: function initThree(props) {
      this.cleanupThree();

      var video = this.ref;

      var geometry = new THREE.PlaneGeometry(props.width, props.height);

      var videoWidth = video.videoWidth,
          videoHeight = video.videoHeight;


      var videoAspect = videoWidth / videoHeight;
      var myAspect = props.width / props.height;

      var texture = new THREE.VideoTexture(video);
      texture.mapping = THREE.CubeReflectionMapping;
      texture.minFilter = THREE.LinearFilter;
      texture.magFilter = THREE.LinearFilter;
      texture.format = THREE.RGBFormat;

      if (videoAspect > myAspect) {
        var newWidth = myAspect * videoHeight;
        var textureAdjustment = newWidth / videoWidth;
        texture.repeat.x = textureAdjustment;
        var cutOffPixels = videoWidth - newWidth;
        texture.offset.x = cutOffPixels / videoWidth / 2;
      } else if (videoAspect < myAspect) {
        var newHeight = 1 / myAspect * videoWidth;
        var _textureAdjustment = newHeight / videoHeight;
        texture.repeat.y = _textureAdjustment;
        var _cutOffPixels = videoHeight - newHeight;
        texture.offset.y = _cutOffPixels / videoHeight / 2;
      }

      var material = new THREE.MeshBasicMaterial({ map: texture });

      this.mesh = new THREE.Mesh(geometry, material);

      var _relativeCoords = (0, _spUtils.relativeCoords)(props.x, props.y, props.width, props.height, this.context.canvasWidth, this.context.canvasHeight),
          _relativeCoords2 = _slicedToArray(_relativeCoords, 2),
          x = _relativeCoords2[0],
          y = _relativeCoords2[1];

      this.mesh.position.set(x, y, 0);
      this.context.scene.add(this.mesh);
    }

    /**
     * Bad! Should dynamically move around, not reboot the whole dang mesh.
     */

  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(newProps) {
      var x = newProps.x,
          y = newProps.y,
          width = newProps.width,
          height = newProps.height;

      if (x !== this.props.x || y !== this.props.y || width !== this.props.width || height !== this.props.height) {
        this.initThree(newProps);
      }
    }
  }, {
    key: "cleanupThree",
    value: function cleanupThree() {
      if (this.mesh) {
        this.context.scene.remove(this.mesh);
      }
      this.mesh = null;
    }
  }, {
    key: "render",
    value: function render() {
      return _react2.default.createElement("video", {
        autoPlay: true,
        ref: this.getRef.bind(this),
        muted: !(this.props.muted === false)
      });
    }
  }]);

  return SPCamera;
}(_react.Component);

SPCamera.propTypes = {
  userId: _propTypes2.default.string.isRequired,
  x: _propTypes2.default.number.isRequired,
  y: _propTypes2.default.number.isRequired,
  width: _propTypes2.default.number.isRequired,
  height: _propTypes2.default.number.isRequired,
  muted: _propTypes2.default.bool
};
SPCamera.contextTypes = {
  scene: _propTypes2.default.object.isRequired,
  canvasWidth: _propTypes2.default.number.isRequired,
  canvasHeight: _propTypes2.default.number.isRequired
};
exports.default = SPCamera;
//# sourceMappingURL=sp-camera.js.map