"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _three = require("three");

var THREE = _interopRequireWildcard(_three);

var _spCanvas = require("./sp-canvas.style");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SPCanvas = function (_Component) {
  _inherits(SPCanvas, _Component);

  function SPCanvas(props) {
    _classCallCheck(this, SPCanvas);

    var _this = _possibleConstructorReturn(this, (SPCanvas.__proto__ || Object.getPrototypeOf(SPCanvas)).call(this));

    _this.state = {
      scale: 1,
      ready: false
    };
    _this.containerProm = new Promise(function (resolve, reject) {
      _this._resolveContainer = resolve;
    });
    _this.canvasProm = new Promise(function (resolve, reject) {
      _this._resolveCanvas = resolve;
    });
    _this.canvasProm.then(function (canvas) {
      _this.start(canvas);
    });
    Promise.all([_this.containerProm, _this.canvasProm]).then(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          container = _ref2[0],
          canvas = _ref2[1];

      _this.handleResize(container, canvas);
      _this.windowListener = _this.handleResize.bind(_this, container, canvas);
      window.addEventListener("resize", _this.windowListener, {
        passive: true
      });
    });
    return _this;
  }

  _createClass(SPCanvas, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.done = true;
      if (this.windowListener) {
        window.removeEventListener("resize", this.windowListener);
      }
    }
  }, {
    key: "containerRef",
    value: function containerRef(container) {
      this._resolveContainer(container);
    }
  }, {
    key: "getChildContext",
    value: function getChildContext() {
      return {
        scene: this.scene,
        canvasWidth: this.props.width,
        canvasHeight: this.props.height
      };
    }
  }, {
    key: "handleResize",
    value: function handleResize(container, canvas) {
      var _props = this.props,
          width = _props.width,
          height = _props.height;
      var _container$getClientR = container.getClientRects()[0],
          containerWidth = _container$getClientR.width,
          containerHeight = _container$getClientR.height;

      var aspect = width / height;
      var containerAspect = containerWidth / containerHeight;
      if (aspect > containerAspect) {
        this.setState({
          scale: containerWidth < width ? containerWidth / width : 1
        });
      } else {
        this.setState({
          scale: containerHeight < height ? containerHeight / height : 1
        });
      }
    }
  }, {
    key: "ref",
    value: function ref(canvas) {
      this._resolveCanvas(canvas);
    }
  }, {
    key: "start",
    value: function start(canvas) {
      var _this2 = this;

      this.scene = new THREE.Scene();

      // const camera = new THREE.OrthographicCamera(this.props.width / -2, this.props.width / 2, this.props.height / 2, this.props.height / -2, 1, 1000);
      var camera = new THREE.OrthographicCamera(this.props.width / -2, this.props.width / 2, this.props.height / 2, this.props.height / -2, 1, 1000);
      camera.position.z = 1000;

      // const geometry = new THREE.PlaneGeometry(960, 540);

      // const texture = new THREE.VideoTexture( video );
      // texture.minFilter = THREE.LinearFilter;
      // texture.magFilter = THREE.LinearFilter;
      // texture.format = THREE.RGBFormat;

      // const material = new THREE.MeshBasicMaterial( { map: texture } );

      // const mesh = new THREE.Mesh( geometry, material );
      // mesh.position.set( -480, 270, 0 );
      // this.scene.add( mesh );

      var renderer = new THREE.WebGLRenderer({
        canvas: canvas,
        antialias: false,
        preserveDrawingBuffer: true
      });

      renderer.setSize(this.props.width, this.props.height);

      var animate = function animate() {
        if (_this2.done) {
          return;
        }
        requestAnimationFrame(animate);
        renderer.render(_this2.scene, camera);
      };

      animate();

      this.setState({ ready: true });
    }
  }, {
    key: "render",
    value: function render() {
      var canvasStyle = {
        width: this.props.width + "px",
        height: this.props.height + "px",
        marginLeft: "-" + this.props.width / 2 + "px",
        marginTop: "-" + this.props.height / 2 + "px",
        transform: "scale(" + this.state.scale + ")"
      };
      var children = void 0;
      if (this.state.ready) {
        children = this.props.children;
      }

      return _react2.default.createElement(
        _spCanvas.CanvasContainer,
        { innerRef: this.containerRef.bind(this) },
        _react2.default.createElement(
          _spCanvas.AutoShrink,
          { style: canvasStyle },
          _react2.default.createElement(_spCanvas.Canvas, {
            className: this.props.className,
            innerRef: this.ref.bind(this)
          }),
          _react2.default.createElement(
            _spCanvas.ChannelContents,
            null,
            children
          )
        )
      );
    }
  }]);

  return SPCanvas;
}(_react.Component);

SPCanvas.propTypes = {
  className: _propTypes2.default.string,
  width: _propTypes2.default.number.isRequired,
  height: _propTypes2.default.number.isRequired,
  children: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.node), _propTypes2.default.node])
};
SPCanvas.childContextTypes = {
  scene: _propTypes2.default.object,
  canvasWidth: _propTypes2.default.number,
  canvasHeight: _propTypes2.default.number
};
exports.default = SPCanvas;
//# sourceMappingURL=sp-canvas.js.map